<template>
    <div>

        <el-form :model="formData" :rules="formRules" ref="dataForm">
            <el-button-group style="display: flex;margin: -50px 0 10px 80%; height: 35px">

                <el-button
                    type="primary"
                    @click.native="saveOrder()"
                >草稿保存
                </el-button
                >
                <el-button
                    type="primary"
                    @click.native="submit('0')"
                >提交订单
                </el-button
                >
            </el-button-group>

            <el-row :gutter="20">
                <el-col :span="2">
                    <div class="ao-text">
                        <span>单据号：</span>
                    </div>
                </el-col>
                <el-col :span="8">
                    <el-form-item prop="corpOrderId">
                        <el-input v-model="formData.corpOrderId" auto-complete="off"
                                  :disabled="corpOrderIdDisabled"></el-input>
                    </el-form-item>
                </el-col>
                <el-col :span="2">
                    <div class="ao-text">
                        <span>单据时间：</span>
                    </div>
                </el-col>
                <el-col :span="8">
                    <el-form-item prop="actDate">
                        <el-date-picker
                            v-model="formData.actDate"
                            type="datetime"
                            placeholder="日期"
                            :disabled="true"
                            style="width: 100%; "
                        >
                        </el-date-picker>
                    </el-form-item>
                </el-col>
            </el-row>
            <el-row :gutter="20">

                <el-col :span="2">
                    <div class="ao-text">
                        <span>单据类型：</span>
                    </div>
                </el-col>
                <el-col :span="8">
                    <el-form-item class="query-form-item" prop="billType">
                        <el-select v-model="formData.action" placeholder="请选择单据类型"
                                   :disabled="corpOrderIdDisabled"
                                   @change="actionChange">
                            <el-option
                                v-for="item in busTypes"
                                :key="item.name"
                                :label="item.name"
                                :value="item.action">
                                <span style="float: left">{{ item.name }}</span>
                            </el-option>
                        </el-select>
                    </el-form-item>
                </el-col>

                <el-col :span="2">
                    <div class="ao-text">
                        <span>当前分库：</span>
                    </div>
                </el-col>

                <el-col :span="8">
                    <el-form-item prop="invWarehouseCode">
                        <el-select v-model="formData.invWarehouseCode" placeholder="当前分库信息"
                                   :disabled="corpOrderIdDisabled" @change="findSubStorageMethod"   filterable>
                            <el-option
                                v-for="item in subInvList"
                                :key="item.name"
                                :label="item.name"
                                :value="item.code">
                                <span style="float: left">{{ item.name }}</span>
                                <span style="float: right; color: #8492a6; font-size: 13px">{{ item.warehouseName }}</span>
                            </el-option>
                        </el-select>
                    </el-form-item>
                </el-col>



            </el-row>

            <el-row :gutter="20">


                <el-col :span="2">
                    <div class="ao-text">
                        <span>往来信息：</span>
                    </div>
                </el-col>
                <el-col :span="8">
                    <el-form-item class="query-form-item" prop="fromCorp"
                                  v-if="curAction.corpType ==0 || curAction.corpType == 3 || (curAction.corpType == 2 && !curAction.genUnit)"
                    >
                        <el-select
                            v-model="formData.fromCorp"
                            filterable
                            remote
                            clearable="true"
                            reserve-keyword
                            placeholder="请输入往来单位"
                            :remote-method="findMethod"
                            :loading="loading"
                            :disabled="corpOrderIdDisabled"
                            @change="unitChange"
                        >
                            <el-option
                                v-for="item in fromOptions"
                                :key="item.name"
                                :label="item.name"
                                :value="item"
                            >
                                <span style="float: left">{{ item.name }}</span>
                            </el-option>
                        </el-select>
                    </el-form-item>
                    <el-form-item class="query-form-item" prop="fromCorp"
                                  v-if="curAction.corpType ==1"
                    >

                        <el-select v-model="formData.fromSubInvCode" placeholder="请选择仓库" clearable="true"
                                   :disabled="corpOrderIdDisabled"  @change="getFormCorp" filterable
                        >
                            <el-option
                                v-for="item in fromSubStorageOptions"
                                :key="item.code"
                                :label="item.name"
                                :value="item.code">
                                <span style="float: left">{{ item.name }}</span>
                                <span style="float: right; color: #8492a6; font-size: 13px">{{ item.warehouseName }}</span>
                                <!--<span style="float: right; color: #8492a6; font-size: 13px">{{ item.action }}</span>-->
                            </el-option>
                        </el-select>

                    </el-form-item>
                    <el-form-item class="query-form-item" prop="fromCorp"
                                  v-if="curAction.corpType ==2 && curAction.genUnit">
                        <el-input v-model="formData.fromCorp" auto-complete="off"
                                  clearable
                                  :disabled="corpOrderIdDisabled"
                                  placeholder="请输入病人住院号"
                        ></el-input>
                    </el-form-item>
                </el-col>
            </el-row>

            <el-row :gutter="20" v-if="enableDept">
                <el-col :span="2">
                    <div class="ao-text">
                        <span>使用科室：</span>
                    </div>
                </el-col>
                <el-col :span="8">
                    <el-form-item class="query-form-item" prop="corpName"
                    >
                        <el-select
                            v-model="formData.deptCode"
                            filterable
                            clearable="true"
                            reserve-keyword
                            placeholder="请选择科室"
                            :remote-method="findDeptMethod"
                            :loading="loading"
                            @focus="findDeptMethod('')"
                        >
                            <el-option
                                v-for="item in fromDeptOptions"
                                :key="item.id"
                                :label="item.name"
                                :value="item.code"
                            >
                                <span style="float: left">{{ item.name }}</span>
                            </el-option>
                        </el-select>
                    </el-form-item>
                </el-col>
            </el-row>


<!--            <el-row :gutter="20">-->
<!--                <el-col :span="20" class="el-col">-->
<!--                    <div class="text item">-->
<!--                        <el-checkbox v-model="formData.outChangeEnable"-->
<!--                                     :disabled="!curAction.changeEnable  || corpOrderIdDisabled">允许出库自动缺量补单-->
<!--                        </el-checkbox>-->

<!--                        <el-checkbox v-model="formData.preCheck"-->
<!--                                     :disabled="corpOrderIdDisabled || curAction.corpType !=2"-->
<!--                        >出入库必须校验预验收库-->
<!--                        </el-checkbox>-->
<!--                        <el-checkbox v-model="formData.vailInv"-->
<!--                        >是否查询库存-->
<!--                        </el-checkbox>-->
<!--                        <el-checkbox v-model="formData.codeFillCheck"-->
<!--                        >采集UDI码时进行三期校验-->
<!--                        </el-checkbox>-->
<!--                    </div>-->

<!--                </el-col>-->
<!--            </el-row>-->
            <el-row :gutter="20" style="margin-top: 12px">
                <el-col :span="2">
                    <div class="ao-text">
                        <el-link
                            target="_blank">{{ scanText }}
                        </el-link>
                    </div>
                </el-col>
                <el-col :span="16">
                    <el-form-item prop="code">
                        <el-input
                            id="inputer"
                            @focus="getInputFocus($event)"
                            @keypress.enter.native="enterKey($event)"
                            ref='inputRef'
                            style="ime-mode:disabled"
                            type="tel"
                            v-model="formData.code"
                        ></el-input>
                    </el-form-item>
                </el-col>
                <el-col :span="2">
                    <el-button
                        type="primary"
                        size="small"
                        @click.native.stop="addCode()"
                        style="height: 31px; margin-left: 20px"
                    >添加
                    </el-button
                    >
                </el-col>


            </el-row>
            <el-row :gutter="20">
                <el-col :span="14" style="margin-left: 40px">

                </el-col>
                <el-col :span="3">
                    <div class="text item" style="margin-left: 30px"> 条码数量：{{ total }}
                    </div>
                </el-col>
            </el-row>
            <el-table v-loading="loading" :data="codeArray" style="width: 100%;" max-height="350" height="350"
                      :row-style="rowStyle"
                      ref="multipleTable">
                <el-table-column
                    type="selection"
                    width="55">
                </el-table-column>
                <el-table-column label="序号" type="index" width="100"></el-table-column>
                <el-table-column
                    label="条码"
                    prop="code"
                    show-overflow-tooltip
                ></el-table-column>
                <el-table-column
                    label="生产日期"
                    prop="produceDate"
                    show-overflow-tooltip
                ></el-table-column>
                <el-table-column
                    label="失效日期"
                    prop="expireDate"
                    show-overflow-tooltip
                ></el-table-column>
                <el-table-column
                    label="批次号"
                    prop="batchNo"
                    show-overflow-tooltip
                ></el-table-column>
                <el-table-column
                    label="序列号"
                    prop="serialNo"
                    show-overflow-tooltip
                ></el-table-column>
                <el-table-column
                    label="供应商"
                    prop="supName"
                    show-overflow-tooltip
                ></el-table-column>

                <el-table-column
                    label="扫码数量"
                    prop="count"
                    show-overflow-tooltip
                ></el-table-column>

                <el-table-column
                    label="实际数量"
                    prop="reCount"
                    show-overflow-tooltip
                ></el-table-column>

                <el-table-column label="操作" fixed="right" width="250">
                    <template slot-scope="scope">
                        <el-button
                            type="text"
                            size="small"
                            @click.native.stop="deleteCode(scope.$index, scope.row)"
                        >减一
                        </el-button
                        >
                        <el-button
                            type="text"
                            size="small"
                            @click.native.stop="bindRl(scope.row)"
                        >选择产品
                        </el-button
                        >
                        <el-button
                            type="text"
                            size="small"
                            @click.native.stop="handleUnitClick(scope.row)"
                        >选择供应商
                        </el-button
                        >
                        <el-button
                            type="text"
                            size="small"
                            @click.native.stop="editCode(scope.row)"
                        >编辑
                        </el-button
                        >
                    </template>
                </el-table-column>
            </el-table>

            <div class="block">
                <el-pagination
                    @current-change="handleCurrentChange"
                    layout="prev, pager, next"
                    :page-size="query.limit"
                    :total="total"
                    :current-page="query.page"
                >
                </el-pagination>
            </div>
        </el-form>
        <el-dialog
            :title="selectUnitTitle"
            :visible.sync="dialogTableVisible"
            v-if="dialogTableVisible"
            width="70%"
            append-to-body
        >
            <DialogSelectUnit
                :codeId="curRow"
                v-on:selectSupUnit="selectSupUnit"
                v-on:closeBindDialog="closeBindDialog"
            ></DialogSelectUnit>
        </el-dialog>
        <el-dialog
            :title="selectRlTitle"
            :visible.sync="selectRlVisible"
            width="80%"
            v-if="selectRlVisible"
            append-to-body
        >
            <selectRlDialog
                :curRow="curRow"
                :curAction="curAction"
                v-on:selectBindRl="selectBindRl"
                v-on:closeBindDialog="closeBindDialog"
            ></selectRlDialog>
        </el-dialog>

        <el-dialog
            :title="editTitle"
            :visible.sync="editCodeVisible"
            :close-on-click-modal="false"
            :close-on-press-escape="false"
            append-to-body width="70%"
            v-if="editCodeVisible"
        >
            <editCodeDialog
                editTye="2"
                :closeCodeDialog="closeCodeDialog"
                :codeDetail="codeDetail">
            </editCodeDialog>
        </el-dialog>

        <el-dialog
            :title="editTitle"
            :visible.sync="editOriginCodeVisible"
            append-to-body width="70%"
            v-if="editOriginCodeVisible">
            <editCodeDialog
                :closeCodeDialog="closeCodeDialog"
                :repeatAddCode="repeatAddCode"
                :codeDetail="formData"
                editTye="1">
            </editCodeDialog>
        </el-dialog>


    </div>


</template>

<script>
import {
    errorCodeList, addOrderWeb, deleteCodesTempById, submitOrderWeb, saveOrderWeb,
    updateCodeBindSup, enterCodeWeb
} from "../../api/inout/order";
import {filterSubByInv} from "../../api/basic/invSubWarehouse";
import draggable from "vuedraggable";
import {parseTime} from "../../filtres/index";
import {getBasicUnitMaintains} from "../../api/basic/basicUnitMaintain"
import {filterAllByLoc, filterAllByUser} from "@/api/basic/invWarehouse";
import {getLocalJoinByUser} from "../../api/basic/busLocalType";
import DialogSelectUnit from "./DialogSelectUnit";
import selectRlDialog from "./DialogSelectRl";
import editCodeDialog from "./editCode";
import A from "../../plugin/KeyScaner"
import {isBlank} from "@/utils/strUtil";
import {selectSysParamByKey} from "@/api/param/systemParamConfig";


export default {
    name: "idQuery",
    props: {
        closeDialog: {
            type: Function,
            required: true,
        },
        idQuery: {
            type: Object,
            required: true,
        },
    },
    data() {
        return {
            codeQuery: {
                code: "",
            },
            query: {
                code: "",
                corpOrderId: "",
                page: 1,
                limit: 10,
            },
            editCodeVisible: false,
            busTypes: [],
            billAction: null,
            actionEnable: false,
            formData: {
                corpOrderId: "",
                code: "",
                actor: "",
                fromCorpId: "",
                fromCorp: null,
                fromType: 2,
                actDate: new Date(),
                action: null,
                locStorageCode: null,
                outChangeEnable: false,
                preCheck: false,
                batchNo: null,
                produceDate: null,
                expireDate: null,
                serialNo: null,
                invWarehouseCode: null,
                subInvCode: null,
                fromSubInvCode: null,
                codeFillCheck: null,
                vailInv: null,
                deptCode: null,
            },
            editOriginCodeVisible: false,
            curId: null,
            storageList: [],
            subInvList: [],
            formRules: {
                temp: [
                    {required: true, message: "请输入条码", trigger: "blur"}
                ],
            },
            isScan: true,
            scanText: "扫码录入：",
            corpOrderIdDisabled: false,
            codeArray: [],
            total: 0,
            loading: false,
            index: null,
            formLoading: false,
            formVisible: false,
            deleteLoading: false,
            orderNo: null,
            fromOptions: [],
            fromSubStorageOptions: [],
            curAction: {
                corpType: 0,
                genUnit: false,
            },
            curRow: null,
            selectRlVisible: false,
            dialogTableVisible: false,
            sitcomScan: false,
            selectRlTitle: "绑定产品",
            selectUnitTitle: "绑定供应商",
            sictomText: "",
            originCode: "",
            checkSuccess: false,
            codeDetail: null,
            editTitle: "编辑条码",
            enableDept: false
        };
    },
    components: {
        draggable,
        DialogSelectUnit, selectRlDialog, editCodeDialog
    },
    methods: {
        submit(formName) {
            if (this.total < 1) {
                this.$message.error('未添加条码');
                return;
            }

            let tQuery = {
                orderId: this.idQuery.id,
                locStorageCode: this.formData.locStorageCode,
                invWarehouseCode: this.formData.invWarehouseCode,
                invStorageCode:this.formData.invStorageCode,
                fromSubInvCode: this.formData.fromSubInvCode,
                subInvCode: this.formData.subInvCode,
                action: this.formData.action,
                fromCorp: this.formData.fromCorp,
                fromCorpId: this.formData.fromCorpId,
                outChangeEnable: this.formData.outChangeEnable,
                preCheck: this.formData.preCheck,
            }
            submitOrderWeb(tQuery)
                .then((response) => {
                    if (response.code === 20000) {
                        this.$message.success("提交成功");
                        this.closeDialog();
                    } else {
                        this.$message.error(response.message);
                    }
                    this.loading = false;
                });
        },
        saveOrder() {
            if (this.formData.action == null || this.formData.action == '') {
                this.$message.error('未选择扫码单据类型');
                return
            }

            if (this.formData.invWarehouseCode == null || this.formData.invWarehouseCode == '') {
                this.$message.error('当前分库不能为空');
                return;
            }
            let tQuery = Object.assign(JSON.parse(JSON.stringify(this.formData)));
            tQuery.orderId = this.idQuery.id;
            tQuery.actDate = parseTime(this.formData.actDate, '{y}-{m}-{d} {h}:{i}:{s}');
            saveOrderWeb(tQuery).then((response) => {
                if (response.code === 20000) {
                    this.closeDialog();
                } else {
                    this.$message.error(response.message);
                }
                this.loading = false;
            });
        },
        closeCodeDialog() {
            //编辑完，获取编辑之后的条码
            this.editCodeVisible = false;
            this.editOriginCodeVisible = false;
            this.getCodeList();
        },
        editCode(row) {
            this.editTitle = "编辑条码";
            this.codeDetail = row;
            this.editCodeVisible = true;
        },
        // 刷新表单
        resetForm() {
            if (this.$refs["dataForm"]) {
                // 清空验证信息表单
                this.$refs["dataForm"].clearValidate();
                // 刷新表单
                this.$refs["dataForm"].resetFields();
                this.getList();
            }
        },
        enterKey(event) {
            this.checkSuccess = true;
            let tQuery = {
                originCode: this.originCode,
                code: this.formData.code.trim(),
            }
            enterCodeWeb(tQuery).then((response) => {

                if (response.code === 20000) {
                    this.$refs.inputRef.focus();
                    this.$refs.inputRef.select();
                    this.formData.code = response.data;
                    this.addCode();
                } else {
                    if (response.code == 502) {
                        this.checkSuccess = false;
                        this.formData.code = response.data;
                        this.originCode = this.formData.code;
                    } else if (response.code == 501) {
                        this.checkSuccess = false;
                        // this.formData.code = response.data;
                        // this.originCode = this.formData.code;
                        this.$message.error(response.message);
                    } else if (response.code == 503) {
                        this.checkSuccess = false;
                        this.formData.code = response.data;
                        this.$confirm(response.message, "提示", {
                            type: "warning",
                        })
                            .then(() => {
                                this.formData.code = response.data;
                                this.addCode();
                            })
                            .catch(() => {
                                this.formData.code = this.originCode;
                            });

                    } else if (response.code == 508) {
                        this.originCode = "";
                        this.formData.code = "01" + response.data.nameCode;
                    } else {
                        this.$alert(response.message, '提示', {
                            confirmButtonText: '确定',
                            type: 'warning',
                            closeOnClickModal: true,
                            callback: action => {
                                this.$refs.inputRef.focus();
                                this.$refs.inputRef.select();
                            }
                        });
                    }
                }
                this.loading = false;
            });
        },
        addCode(event) {

            this.originCode = "";
            this.sictomText = "";
            this.formData.corpOrderId = this.formData.corpOrderId.trim();
            this.formData.batchNo = "";
            this.formData.produceDate = "";
            this.formData.expireDate = "";
            this.formData.serialNo = "";
            if (event != null) {
                event.target.select();
            }
            this.actionEnable = true;
            this.$refs.inputRef.select();
            if (this.$isBlank(this.formData.action)) {
                this.$message.warning("请选择单据类型！");
                return;
            }

            if (this.formData.invWarehouseCode == null || this.formData.invWarehouseCode == '') {
                this.$message.error('当前分库不能为空');
                return;
            }

            // if (this.$isBlank(this.formData.fromCorp)) {
            //     this.$message.error('当前往来单位不能为空');
            //     return;
            // }

            if (this.curAction.corpType == 1) {
                if (this.$isBlank(this.formData.fromSubInvCode)) {
                    this.$message.error('当前往来分库不能为空');
                    return;
                }
            }

            if (this.$isBlank(this.formData.corpOrderId)) {
                let date = new Date();
                this.formData.corpOrderId = parseTime(date, '{y}{m}{d}{h}{i}{s}') + Math.ceil(Math.random() * 89 + 10);
            }
            this.formData.code = this.formData.code.trim();
            if (this.$isBlank(this.formData.code)) return;
            this.loading = true;

            let tQuery = Object.assign(JSON.parse(JSON.stringify(this.formData)));
            tQuery.orderId = this.idQuery.id;
            tQuery.actDate = parseTime(this.formData.actDate, '{y}-{m}-{d} {h}:{i}:{s}');
            tQuery.action = this.formData.action;
            this.addCodeSubmit(tQuery);
            this.$refs.inputRef.select();
        },

        repeatAddCode(editData) {
            let tQuery = editData;
            tQuery.orderId = this.idQuery.id;
            tQuery.actDate = parseTime(this.formData.actDate, '{y}-{m}-{d} {h}:{i}:{s}');
            tQuery.action = this.formData.action;
            this.closeCodeDialog();
            this.addCodeSubmit(tQuery);

        },
        addCodeSubmit(tQuery) {

            addOrderWeb(tQuery).then((response) => {
                if (response.code === 20000) {
                    this.idQuery.id = response.data.orderId;
                    if (response.data.errMsg != null) {
                        this.$alert(response.data.errMsg, '提示', {
                            confirmButtonText: '确定',
                            type: 'warning',
                            closeOnClickModal: true,
                            callback: action => {
                            }
                        });
                    }
                    this.corpOrderIdDisabled = true;
                    this.getCodeList();
                    this.$refs.inputRef.focus();
                    this.$refs.inputRef.select();
                } else {
                    if (response.code == 502) {
                        this.curRow = response.data;
                        this.idQuery.id = this.curRow.orderId;
                        this.getCodeList();
                        this.selectRlTitle = response.message;
                        this.bindRl(response.data);
                    } else if (response.code == 503) {
                        this.curRow = response.data;
                        this.idQuery.id = this.curRow.orderId;
                        this.getCodeList();
                        this.selectUnitTitle = response.message;
                        this.handleUnitClick(response.data);
                    } else if (response.code == 504) {

                        this.$confirm(response.message, "提示", {
                            confirmButtonText: "确定",
                            cancelButtonText: "忽略",
                            type: "error",
                        }).then(() => {
                            tQuery.ignoreExpire = true;
                            this.addCodeSubmit(tQuery)
                        }).catch(() => {

                        });
                    } else if (response.code == 505) {
                        this.$confirm(response.message, "提示", {
                            confirmButtonText: "确定",
                            cancelButtonText: "忽略",
                            type: "warning",
                        }).then(() => {
                            tQuery.ignoreRecentExpire = true;
                            this.addCodeSubmit(tQuery)
                        }).catch(() => {

                        });
                    } else if (response.code == 507) {
                        this.editTitle = response.message;
                        this.editOriginCodeVisible = true;
                        this.formData.produceDate = response.data.produceDate;
                        this.formData.expireDate = response.data.expireDate;
                        this.formData.batchNo = response.data.batchNo;
                        this.formData.serialNo = response.data.serialNo;

                        this.$message({
                            type: 'error',
                            message: "提交失败！" + this.editTitle,
                            customClass: 'messageIndex'
                        });
                    } else {
                        this.$alert(response.message, '提示', {
                            confirmButtonText: '确定',
                            type: 'warning',
                            closeOnClickModal: true,
                            callback: action => {
                                this.$refs.inputRef.focus();
                            }
                        });
                    }
                }
                this.loading = false;
            });
        },

        unitChange(row) {
            this.formData.fromCorpId = row.erpId;
            this.formData.fromCorp = row.name;
            this.curRow = row;
        },
        storageChange(row) {
            this.formData.fromSubInvCode = "";
            this.formData.fromCorpId = row.code;
            this.formData.fromCorp = row.name;
            this.findSubStorageMethod();
        },

        deleteCode(index, row) {
            this.$confirm("是否确定移除一个条码?", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            }).then(() => {
                this.loading = true;
                let tQuery = {
                    id: row.id
                }
                deleteCodesTempById(tQuery)
                    .then((response) => {
                        if (response.code === 20000) {
                            this.getCodeList();
                        } else {
                            this.$message.error(response.message);
                        }
                        this.loading = false;
                    });
            }).catch(() => {
            });
        },
        getInputFocus(event) {
            event.currentTarget.select();
            // var inputer = document.getElementById("inputer");
            // inputer.focus();
        },
        tableSelection() {
            this.$refs.multipleTable.clearSelection();
            this.$refs.multipleTable.toggleAllSelection();
        },
        handleSizeChange(val) {
            this.query.limit = val;
            this.getCodeList();
        },
        handleCurrentChange(val) {
            this.query.page = val;
            this.getCodeList();
        },
        getCodeList() {
            this.loading = true;
            this.query.orderId = this.idQuery.id;
            errorCodeList(this.query) //查找该单号下的所有条码
                .then((response) => {
                    this.codeArray = response.data.list || [];
                    this.total = response.data.total || 0;
                    for (let i = 0; i < this.codeArray.length; i++) {
                        this.codeArray[i].fromType = this.formData.fromType;
                        this.codeArray[i].billType = this.formData.billType;
                    }
                    this.tableSelection();
                    this.loading = false;
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                    this.total = 0;
                });
        },
        intentBack() {
            this.$router.go(-1);
        },
        getBusType() {
            this.formData.billType=null;
            let query = {
                code: this.formData.invWarehouseCode,
                enabled: true,
            };
            if (isBlank(query.code)) {
                query.code = this.$store.getters.locSubInvCode;
            }
            getLocalJoinByUser(query)
                .then((response) => {

                        this.busTypes = response.data.list || [];
                        if (this.formData.action != null) {
                            this.curAction = this.getActionItem(this.formData.action);
                            if (this.curAction != null) {
                                this.formData.vailInv = this.curAction.vailInv;
                                this.formData.codeFillCheck = this.curAction.codeFillCheck;
                            }
                        } else {
                            this.curAction = {corpType: 0, genUnit: false, changeEnable: false,};
                            this.formData.action = null;
                        }
                    }
                )
                .catch(() => {
                });
        },
        subStorageChange() {
            this.getBusType();
        },
        geActionName(action) {
            this.busTypes.forEach((obj) => {
                if (obj.action == action) {
                    return obj.name;
                }
            });
        }
        ,

        locCHange() {
            if (this.$isNotBlank(this.formData.invWarehouseCode)) {
                this.formData.invWarehouseCode = "";
            }
            this.findStorageMethod();
            this.findSubInvByInv(this.formData.locStorageCode);
        }
        ,
        findMethod(query) {

            this.fromOptions = [];
            let cQuery = {
                key: query,
                corpType: null,
                outType: null,
            };
            if (this.curAction.corpType == 3) {//特殊往来
                cQuery.corpType = 4;
                this.formData.fromCorpId = this.curAction.defaultUnit;
            } else if (this.curAction.corpType == 2)//客户
            {
                cQuery.corpType = 1;
                cQuery.outType = 2;

            } else if (this.curAction.corpType == 0) {
                cQuery.corpType = 2;
            } else return;


            getBasicUnitMaintains(cQuery)
                .then((response) => {
                    this.loading = false;
                    this.fromOptions = response.data.page.list || [];
                    if (this.curAction.corpType == 3) {
                        for (let i = 0; i < this.fromOptions.length; i++) {
                            if (this.fromOptions[i].erpId == this.formData.fromCorpId) {
                                this.formData.fromCorp = this.fromOptions[i].name;
                            }
                        }
                    }
                })
                .catch(() => {
                    this.loading = false;
                });
        }
        ,


        findSubStorageMethod() {
            this.formData.invStorageCode= this.subInvList.find(item => item.code == this.formData.invWarehouseCode).parentId
            this.formData.locStorageCode= this.subInvList.find(item => item.code == this.formData.invWarehouseCode).parentId
            this.getBusType();
            let cQuery = {
                code: this.formData.invWarehouseCode,
                filter: 2,
            };
            filterSubByInv(cQuery)
                .then((response) => {
                    this.fromSubStorageOptions = response.data || [];
                })
                .catch(() => {
                });
        }
        ,
        getFormCorp(){
            this.formData.subInvCode= this.fromSubStorageOptions.find(item => item.code == this.formData.fromSubInvCode).parentId
            this.formData.fromCorp=this.fromSubStorageOptions.find(item => item.code == this.formData.fromSubInvCode).warehouseName
            this.formData.fromCorpId=this.fromSubStorageOptions.find(item => item.code == this.formData.fromSubInvCode).code
        },

        findSubInvByInv(invCode) {
            this.subInvList = [];
            let query = {
                filter:3
            };
            filterSubByInv(query)
                .then((response) => {
                    this.subInvList = response.data || [];
                    if (this.subInvList != null) {
                        this.getBusType();
                        this.findSubStorageMethod();
                    }
                })
                .catch(() => {
                });
        }
        ,

        findDeptMethod() {
            let query = {
                flag: 1
            };
            filterDepts(query)
                .then((response) => {
                    this.loading = false;
                    this.fromDeptOptions = response.data.list || [];
                })
                .catch(() => {
                    this.loading = false;
                    this.fromDeptOptions = [];
                });
        },
        getActionName(action) {
            for (let i = 0; i < this.busTypes.length; i++) {
                if (this.busTypes[i].action === action) {
                    return this.busTypes[i].advanceType;
                }
            }
        }
        ,
        getActionItem(action) {
            for (let i = 0; i < this.busTypes.length; i++) {
                if (this.busTypes[i].action == action) {
                    return this.busTypes[i];
                }
            }
        }
        ,
        actionChange(item) {

            this.curAction = this.getActionItem(item);
            this.findMethod();

            this.$set(this.formData, "vailInv", this.curAction.vailInv);
            this.$set(this.formData, "preCheck", this.curAction.scanPreIn);
            this.$set(this.formData, "outChangeEnable", this.curAction.ullageFill);
            this.$set(this.formData, "codeFillCheck", this.curAction.codeFillCheck);

        }
        ,

//绑定数据
        bindRl(val) {
            this.curRow = val;
            this.selectRlVisible = true;
        }
        ,
        handleUnitClick(row) {
            this.curRow = row;
            this.dialogTableVisible = true;
        }
        ,
        selectSupUnit(row) {
            let query = {
                id: this.curRow.id,
                supId: row.erpId,
            };
            updateCodeBindSup(query).then((response) => {
                if (response.code == 20000) {
                    this.$message.success("绑定成功");
                    this.idQuery.id = this.curRow.orderId;
                    this.getCodeList();
                } else {
                    this.$message.error(response.message);
                }
            }).catch(() => {

            });
        }
        ,


        selectBindRl(row) {
            let query = {
                id: this.curRow.id,
                relId: row.id,
                mySupId: row.unitFk,
            };
            updateCodeBindSup(query).then((response) => {
                if (response.code == 20000) {
                    this.$message.success("绑定成功");
                    this.idQuery.id = this.curRow.orderId;
                    this.getCodeList();
                } else {
                    if (response.code == 503) {
                        this.curRow = response.data;
                        this.idQuery.id = this.curRow.orderId;
                        this.getCodeList();
                        this.selectUnitTitle = response.message;
                        this.handleUnitClick(response.data);
                    } else
                        this.$message.error(response.message);
                }
            }).catch(() => {

            });
        }
        ,
        closeBindDialog(val) {
            this.selectRlVisible = false;
            this.dialogTableVisible = false;
        }
        ,

        rowStyle({row, rowIndex}) {
            let rowBackground = {};
            if (!this.$isNotBlank(row.supId) || !this.$isNotBlank(row.relId)) {
                //rowBackground.background="#f6f5ee";
                rowBackground.color = '#f60303';
            }

            return rowBackground;
        }
        ,

    },


    filters: {}
    ,
    mounted() {
        document.body.ondrop = function (event) {
            event.preventDefault();
            event.stopPropagation();
        };
        var that = this;
        var inputer = document.getElementById("inputer");
        window.sc = new A.KeyScaner(inputer);//传入要监听的DOM节点
        sc.onInput = function (text) {
            if (text.includes("delete")) {
                that.formData.code = "";
                that.sictomText = "";
                that.originCode = "";
                return;
            }
            if (that.sitcomScan) {
                let tempTxt = text;
                let str = tempTxt.replace(/[\r]/g, "");
                that.sictomText = that.sictomText + str;
                that.formData.code = that.sictomText;
            } else {

                that.formData.code = text;
                // setTimeout(function(){  that.formData.code = text; }, 3000);


            }
        };
        inputer.focus();

    }
    ,
    created() {

        this.formData.code = '';
        this.formData.actDate = new Date();
        this.codeArray = [];



        if (this.$isNotBlank(this.idQuery.id)) {
            this.formData.actDate = new Date(this.idQuery.actDate);
            this.formData.corpOrderId = this.idQuery.corpOrderId;
            this.corpOrderIdDisabled = true;
            this.formData.action = this.idQuery.action;
            this.formData.fromCorp = this.idQuery.fromCorp;
            this.formData.fromCorpId = this.idQuery.fromCorpId;
            this.formData.locStorageCode = this.idQuery.locStorageCode;
            this.formData.invWarehouseCode = this.idQuery.invWarehouseCode;
            this.formData.fromSubInvCode = this.idQuery.fromSubInvCode;
            this.formData.outChangeEnable = this.idQuery.outChangeEnable;
            this.formData.preCheck = this.idQuery.preCheck;
            this.actionEnable = true;
            this.getCodeList();
            this.findSubStorageMethod();
        } else {
            this.corpOrderIdDisabled = false;
            if (JSON.stringify(this.$route.query) === '{}') {
                // this.formData.corpOrderId = new Date().getTime() + (Math.ceil(Math.random() * 10 + 10) + '');
                let date = new Date();
                this.formData.corpOrderId = parseTime(date, '{y}{m}{d}{h}{i}{s}') + Math.ceil(Math.random() * 89 + 10);
            } else {
                // 将参数拷贝进查询对象
                let query = this.$route.query;
                this.orderNo = query.id;

                this.query = Object.assign(this.query, query);
                this.query.limit = parseInt(this.query.limit);
                this.query.corpOrderId = query.id;
                // 加载表格数据
                // this.getCodeList();
            }
            this.formData.invWarehouseCode = this.$store.getters.locSubInvCode;
            this.formData.invStorageCode=this.$store.getters.locInvCode;
            this.formData.locStorageCode = this.$store.getters.locInvCode;
        }
        this.findSubInvByInv(this.formData.locStorageCode);
        //查询是否启用多级仓库，判断是否启用部门
        selectSysParamByKey({paramKey: "muti_inv_mode"}).then((res) => {
            if (res.code === 20000) {
                if (res.data.paramValue === "0") {
                    this.enableDept = true;
                }
            }
        })
    }
};
</script>


<style>

.messageIndex {
    z-index: 9999 !important;
}

.ao-text {
    width: 100%;
    font-size: 13px;
    font-family: "Microsoft YaHei";
    float: right;
    text-align: right;
    margin-top: 10px;
}

#inputer {
    width: 100%;
    min-height: 30px;
    background-color: white;
    border: #d0d0d0;
    border-style: solid;
    border-width: 0.1px;
    color: #4a4a4a;

}

#inputer:focus {
    width: 100%;
    min-height: 30px;
    background-color: white;
    border: #0080FF;
    border-style: solid;
    border-width: 0.1px;
    color: #4a4a4a;

}

.ime-disabled {
    ime-mode: disabled;
}
</style>



